#if defined(__cplusplus)
extern "C"
{
#endif

typedef unsigned short * MODBUSBSTR;

#define MAX_MODBUS_DATA_LENGTH 240



/////////////////////////////////////////////////////////////
//
// Possible error codes generated by WA_TCP_MODBUS library functions
//
#define GOOD 0
#define BAD -1
#define TCP_TIMEOUT -1

#define HOST_REJECTED_DATA_LENGTH    -2
#define HOST_REJECTED_DATA_ADDRESS  -3
#define DEVICE_REJECTED_DATA_ADDRESS -4
#define DEVICE_REJECTED_DATA_VALUE   -5

// Socket API error return codes
#define ERROR_SOCKET_ERROR			-1
#define ERROR_SOCK_INITIALIZATION   -1001
#define ERROR_SOCK_CREATION		    -1002
#define ERROR_RESOLVING_HOST_NAME	-1003
#define ERROR_ESTABLISHING_CONNECTION -1004
#define ERROR_SENDING_STRING			-1005
#define ERROR_ZERO_BYTES_RECEIVED	-1006




/////////////////////////////////////////////////////////////
//
// Function prototypes for WA_TCP_MODBUS library functions
//
extern __declspec(dllexport) short _stdcall WA_open_VB_TCPModbusConnection(MODBUSBSTR serverIPAddress, unsigned short serverPort);

extern __declspec(dllexport) short _stdcall WA_openTCPModbusConnection(char* serverIPAddress, unsigned short serverPort);

extern __declspec(dllexport) short _stdcall WA_readTCPModbusDevice(short slaveAddress, long startAddress, short *data, short numPoints);

extern __declspec(dllexport) short _stdcall WA_writeTCPModbusDevice(short slaveAddress, long startAddress, short *data, short numPoints);

extern __declspec(dllexport) void _stdcall WA_closeTCPModbusConnection(void);


#if defined(__cplusplus)
}
#endif
