VERSION 5.00
Object = "{1128ECB0-E5EC-499A-A2C7-B73A47615C01}#1.0#0"; "ModTCP.ocx"
Begin VB.Form Form1 
   Caption         =   "Modbus TCP Reader"
   ClientHeight    =   6720
   ClientLeft      =   3375
   ClientTop       =   1425
   ClientWidth     =   4800
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   6720
   ScaleWidth      =   4800
   Begin modTCP.ModTcpCtrl ModTcp1 
      Left            =   90
      Top             =   5280
      _ExtentX        =   847
      _ExtentY        =   847
   End
   Begin VB.CommandButton cmdPoll 
      Caption         =   "Start Polling"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   405
      Left            =   184
      TabIndex        =   13
      Top             =   6300
      Width           =   4425
   End
   Begin VB.CommandButton cmdRead 
      Caption         =   "Read Once"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   465
      Left            =   184
      TabIndex        =   10
      Top             =   5790
      Width           =   4425
   End
   Begin VB.ComboBox cmbAddress 
      Height          =   315
      ItemData        =   "Form1.frx":0442
      Left            =   390
      List            =   "Form1.frx":04A6
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   2400
      Width           =   1245
   End
   Begin VB.Frame FrameDoComm 
      Caption         =   "Controller Settings"
      Height          =   3945
      Left            =   214
      TabIndex        =   1
      Top             =   1740
      Width           =   4395
      Begin VB.CommandButton cmdWrite 
         Caption         =   "Write"
         Height          =   345
         Left            =   180
         TabIndex        =   12
         Top             =   2400
         Width           =   1005
      End
      Begin VB.TextBox txtWriteValue 
         Height          =   345
         Left            =   180
         TabIndex        =   11
         Text            =   "0"
         Top             =   1950
         Width           =   1005
      End
      Begin VB.TextBox txtResult 
         Height          =   2655
         Left            =   1770
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   9
         Top             =   1110
         Width           =   2505
      End
      Begin VB.TextBox txtNumItems 
         Height          =   315
         Left            =   3270
         TabIndex        =   8
         Text            =   "1"
         Top             =   660
         Width           =   765
      End
      Begin VB.TextBox txtDataAddress 
         Height          =   315
         Left            =   1770
         TabIndex        =   7
         Text            =   "40001"
         Top             =   660
         Width           =   1005
      End
      Begin VB.Label Label3 
         Caption         =   "Num Items"
         Height          =   255
         Left            =   3270
         TabIndex        =   6
         Top             =   390
         Width           =   1005
      End
      Begin VB.Label Label2 
         Caption         =   "Data Address"
         Height          =   255
         Left            =   1800
         TabIndex        =   5
         Top             =   360
         Width           =   1005
      End
      Begin VB.Label Label1 
         Caption         =   "Controller Address"
         Height          =   255
         Left            =   210
         TabIndex        =   3
         Top             =   360
         Width           =   1515
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Connection"
      Height          =   1335
      Left            =   192
      TabIndex        =   0
      Top             =   270
      Width           =   4425
      Begin VB.TextBox txtIPAddr 
         Height          =   285
         Left            =   255
         TabIndex        =   2
         Top             =   540
         Width           =   1485
      End
      Begin VB.Label Label4 
         Caption         =   "Host IP Address / Name "
         Height          =   285
         Left            =   90
         TabIndex        =   14
         Top             =   210
         Width           =   1815
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

' ModbusReader TCP
'
' Demo program for using the WatConnect ModTCP control.
'


Const MaxRetries = 5 'How many times to retry a communication that has failed.
Const MTCP_READ% = 0
Const MTCP_WRITE% = 1


Private mDoingRead As Boolean
Private mDoingWrite As Boolean

Private lastIPAddress$
Private lastDataAddress$
Private lastSlaveAddress%

Private mPolling As Boolean

Private CurrentRetry As Integer



Private Sub updateButtons()
    'Only allows reading or writing data if a non zero length string is specified for the Host Name.
    If Len(txtIPAddr.Text) = 0 Then
        cmdRead.Enabled = False
        cmdWrite.Enabled = False
        cmdPoll.Enabled = False
    Else
        cmdRead.Enabled = True
        cmdWrite.Enabled = True
        cmdPoll.Enabled = True
    End If
End Sub


Private Sub cmdPoll_Click()
    'Depending on the current polling state, starts or stops polling (continously reading the same registers).
    If mPolling Then
        cmdPoll.Caption = "Start Polling"
        cmdRead.Enabled = True
        cmdWrite.Enabled = True
        mPolling = False
    Else
        cmdPoll.Caption = "Stop Polling"
        mPolling = True
        cmdRead.Enabled = False
        cmdWrite.Enabled = False
        Call DoRead
    End If
End Sub

Private Sub cmdRead_Click()
    Call DoRead
End Sub
Private Sub cmdWrite_Click()
    Call DoWrite
End Sub

Private Sub DoWrite()
    Dim tmpInt%
    Dim tStr$
    Dim i%
    
    'Sends data to the specifed register.  Only single register writes are shown here.  Multiregister writes
    'are also supported.
    
    On Error GoTo DoWriteErrHand
    
    Call SaveDataAddress
    Call SaveSlaveAddress
    Call SaveIPAddress
    
    With ModTcp1
        'Host Name
        .HostName = txtIPAddr.Text
        'Slave Address
        .NodeAddr = CInt(cmbAddress.List(cmbAddress.ListIndex))
        
        'Start Address
        .DataAddr = CLng(txtDataAddress.Text)
        
        'Number of items
        .DataQty = 1
        .DataElement(0) = CInt(txtWriteValue.Text)
        
        'Start the write transaction.
        Call .Action(MTCP_WRITE)
'        Call .WriteData
        
        'Display the string that was sent to the slave
        tStr = .SentString
        Call frmCommStrings.AddStringToWindow(tStr)
    End With
    mDoingWrite = True
ResumeHere:
    Exit Sub
DoWriteErrHand:
    MsgBox "Error reading.  Error was: " & Err.Description & "(" & Err.Number & ")"
    Resume ResumeHere
    
End Sub
Private Sub SaveDataAddress()
    If txtDataAddress.Text <> lastDataAddress Then
        'If the Data Address changed store it in the registry so that the same address will be displayed
        'when the program starts up again
        Call SaveSetting(App.ProductName, "StartUp", "DataAddress", txtDataAddress.Text)
        lastDataAddress = txtDataAddress.Text
    End If
End Sub
Private Sub SaveSlaveAddress()
    With cmbAddress
        If .ListIndex <> lastSlaveAddress Then
            'If the Slave Address changed store it in the registry so that the same address will be displayed
            'when the program starts up again
            Call SaveSetting(App.ProductName, "StartUp", "SlaveAddress", CStr(.ListIndex))
            lastSlaveAddress = .ListIndex
        End If
    End With
End Sub
Private Sub SaveIPAddress()
    If txtIPAddr.Text <> lastIPAddress Then
            'If the Slave Address changed store it in the registry so that the same address will be displayed
            'when the program starts up again
            Call SaveSetting(App.ProductName, "StartUp", "IPAddress", txtIPAddr.Text)
    
        lastIPAddress = txtIPAddr.Text
    End If
End Sub
Private Sub DoRead()
    'Reads data from the specified registers.
    
    Dim tStr$
    Dim i%
    
    On Error GoTo DoReadErrHand
    Call SaveDataAddress
    Call SaveSlaveAddress
    Call SaveIPAddress
    
    With ModTcp1
        'Host Name
        .HostName = txtIPAddr.Text
        'Slave Address
        .NodeAddr = CInt(cmbAddress.List(cmbAddress.ListIndex))
        
        
        'Data Start Address
        .DataAddr = CLng(txtDataAddress.Text)
        
        'Number of items
        .DataQty = CInt(txtNumItems.Text)
        
        'Start the read transaction
        Call .Action(MTCP_READ)
        
        'Display the string that was sent to the slave in the comm strings window
        tStr = .SentString
        Call frmCommStrings.AddStringToWindow(tStr)
    End With
    mDoingRead = True
ResumeHere:
    Exit Sub
    
DoReadErrHand:
    MsgBox "Error reading.  Error was: " & Err.Description & "(" & Err.Number & ")"
    Resume ResumeHere
End Sub



Private Sub Form_Load()
    'Read the registry to find the settings from the last time this program was run
    txtIPAddr.Text = GetSetting(App.ProductName, "StartUp", "IPAddress", "")
    txtDataAddress.Text = GetSetting(App.ProductName, "StartUp", "DataAddress", "40001")
    cmbAddress.ListIndex = CInt(GetSetting(App.ProductName, "StartUp", "SlaveAddress", "0"))
    Call updateButtons
    
    'Put up the window that displays the Modbus TCP strings
    frmCommStrings.Top = Me.Top
    frmCommStrings.Left = Me.Left + Me.Width
    frmCommStrings.Show vbModeless
    
    'Set the number of milliseconds to wait for a response to a transaction
    ModTcp1.MsgTimeout = 8000
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    'Take down the comm strings window before exiting
    Unload frmCommStrings
End Sub



Private Sub ProcessError(ByVal errNum%)
    'If an error occured, display a string in the result box indicating what the error was.
    'If the number of retries has not been exhausted, retry the commincation.
    Dim tStr$
    
    CurrentRetry = CurrentRetry + 1
    If mDoingRead Then
        tStr = "Error during read: "
        If CurrentRetry < MaxRetries Then
            Call DoRead
        End If
    ElseIf mDoingWrite Then
        tStr = "Error during write: "
        If CurrentRetry < MaxRetries Then
            Call DoWrite
        End If
    End If
    tStr = tStr & GetErrorString(errNum) & " (" & errNum & ")"
    txtResult.Text = tStr
End Sub


Private Function GetErrorString(ByVal errNum%)
    'Returns a string based on the error number that has occurred.
    Select Case errNum
        Case -7:
            GetErrorString = "Invalid response"
        Case -6:
            GetErrorString = "Can't open winsock port"
        Case -1:
            GetErrorString = "Time-Out"
        Case 1:
            GetErrorString = "Illegal function"
        Case 2:
            GetErrorString = "Illegal data address"
        Case 3:
            GetErrorString = "Illegal data value"
        Case 4:
            GetErrorString = "Illegal response length"
        Case 5:
            GetErrorString = "Acknowledge"
        Case 6:
            GetErrorString = "Slave device busy"
        Case 7:
            GetErrorString = "Negative acknowledge"
        Case 8:
            GetErrorString = "Memory parity error"
    End Select
    
End Function



Private Sub ModTcp1_TransactionDone(ByVal Result As Integer)
    'Event generated by the ModTcp indicating that the transaction completed or timed out.
    
    Dim tStr$
    Dim i%
    If Result <> -1 And Result <> -6 Then
        'Display the Modbus string returned from the slave
        'On a timeout, don't try to print the return string because nothing was returned
        Call frmCommStrings.AddStringToWindow(ModTcp1.ReturnString)
    End If
    
    If Result <> 0 Then
        'An error occured so figure out what it was
        Call ProcessError(Result)
    Else
        'A successful transaction occured.
        
        CurrentRetry = 0
        If mDoingRead Then
            'Display the data returned by the slave.
            For i = 0 To ModTcp1.DataQty - 1
                tStr = tStr & ModTcp1.DataElement(i) & vbCrLf
            Next i
            txtResult.Text = tStr
            mDoingRead = False
        ElseIf mDoingWrite Then
            mDoingWrite = False
        End If
    End If
    If mPolling Then
        DoRead
    End If
End Sub



Private Sub txtIPAddr_Change()
    Call updateButtons
End Sub


